
VideoMem = $fc00

ScrollLeft:
  di
  ld hl,0
  ld bc,1024
LoopLeft:
  dec hl
  ex af,af'
  rl (hl)
  ex af,af'
  dec c
  jp nz,LoopLeft
  dec b               ; have to test these separately or else calc crashes.... dunno why
  jp nz,LoopLeft
  ei
  ret
  
ScrollRight:
  di
  ld hl,VideoMem-1
  ld bc,1024
LoopRight:
  inc hl
  ex af,af'
  rr (hl)
  ex af,af'
  dec c
  jp nz,LoopRight
  dec b               ; have to test these separately or else calc crashes.... dunno why
  jp nz,LoopRight
  ei
  ret
  
ScrollUp:
  ld hl,VideoMem+16
  ld de,VideoMem
  ld bc,1008
  ldir
  ret

ScrollDown:
  ld hl,0-17
  ld de,0-1
  ld bc,1008
  lddr
  ret
  
ScrollLeftByte:
  ld hl,VideoMem+1
  ld de,VideoMem
  ld bc,1023
  ldir
  ret

ScrollRightByte:
  ld hl,0-2
  ld de,0-1
  ld bc,1023
  lddr
  ret
  
ScrollUpByte:
  ld hl,16*8+VideoMem
  ld de,VideoMem
  ld bc,1024-(16*8)
  ldir
  ret
  
ScrollDownByte:
  ld hl,0-1-(16*8)
  ld de,0-1
  ld bc,1024-(16*8)
  lddr
  ret